searchNodes=[{"doc":"NIF for secp256k1 curve functions. It uses https://github.com/paritytech/libsecp256k1","ref":"ExSecp256k1.html","title":"ExSecp256k1","type":"module"},{"doc":"Create a public key from a private key Examples iex&gt; private_key = :crypto . strong_rand_bytes ( 32 ) iex&gt; { :ok , _public_key } = ExSecp256k1 . create_public_key ( private_key )","ref":"ExSecp256k1.html#create_public_key/1","title":"ExSecp256k1.create_public_key/1","type":"function"},{"doc":"Tweak public key by adding to it Examples iex&gt; private_key = &lt;&lt; 72 , 91 , 33 , 135 , 186 , 13 , 21 , 144 , 75 , 36 , 27 , 203 , 157 , 203 , 177 , 166 , 86 , 92 , 151 , 137 , 148 , 205 , 234 , 174 , 192 , 12 , 9 , 227 , 208 , 173 , 74 , 69 &gt;&gt; iex&gt; { :ok , _result } = ExSecp256k1 . private_key_tweak_add ( private_key , private_key )","ref":"ExSecp256k1.html#private_key_tweak_add/2","title":"ExSecp256k1.private_key_tweak_add/2","type":"function"},{"doc":"Tweak private key by multiplying it Examples iex&gt; private_key = &lt;&lt; 72 , 91 , 33 , 135 , 186 , 13 , 21 , 144 , 75 , 36 , 27 , 203 , 157 , 203 , 177 , 166 , 86 , 92 , 151 , 137 , 148 , 205 , 234 , 174 , 192 , 12 , 9 , 227 , 208 , 173 , 74 , 69 &gt;&gt; iex&gt; { :ok , _result } = ExSecp256k1 . private_key_tweak_mult ( private_key , private_key )","ref":"ExSecp256k1.html#private_key_tweak_mult/2","title":"ExSecp256k1.private_key_tweak_mult/2","type":"function"},{"doc":"Compresses public key Examples iex&gt; public_key = &lt;&lt; 4 , 204 , 170 , 92 , 229 , 234 , 207 , 153 , 33 , 250 , 27 , 208 , 37 , 71 , 183 , 155 , 104 , 155 , 45 , 114 , 7 , 156 , 83 , 199 , 245 , 83 , 32 , 128 , 45 , 174 , 96 , 24 , 38 , 220 , 210 , 198 , 20 , 132 , 174 , 75 , 63 , 131 , 95 , 120 , 101 , 186 , 93 , 179 , 95 , 14 , 206 , 46 , 48 , 6 , 129 , 8 , 146 , 40 , 135 , 251 , 42 , 71 , 4 , 83 , 222 &gt;&gt; iex&gt; { :ok , _result } = ExSecp256k1 . public_key_compress ( public_key )","ref":"ExSecp256k1.html#public_key_compress/1","title":"ExSecp256k1.public_key_compress/1","type":"function"},{"doc":"Decompresses public key Examples iex&gt; public_key = &lt;&lt; 2 , 204 , 170 , 92 , 229 , 234 , 207 , 153 , 33 , 250 , 27 , 208 , 37 , 71 , 183 , 155 , 104 , 155 , 45 , 114 , 7 , 156 , 83 , 199 , 245 , 83 , 32 , 128 , 45 , 174 , 96 , 24 , 38 &gt;&gt; iex&gt; { :ok , _result } = ExSecp256k1 . public_key_decompress ( public_key )","ref":"ExSecp256k1.html#public_key_decompress/1","title":"ExSecp256k1.public_key_decompress/1","type":"function"},{"doc":"Tweak public key by adding to it Examples iex&gt; public_key = &lt;&lt; 4 , 204 , 170 , 92 , 229 , 234 , 207 , 153 , 33 , 250 , 27 , 208 , 37 , 71 , 183 , 155 , 104 , 155 , 45 , 114 , 7 , 156 , 83 , 199 , 245 , 83 , 32 , 128 , 45 , 174 , 96 , 24 , 38 , 220 , 210 , 198 , 20 , 132 , 174 , 75 , 63 , 131 , 95 , 120 , 101 , 186 , 93 , 179 , 95 , 14 , 206 , 46 , 48 , 6 , 129 , 8 , 146 , 40 , 135 , 251 , 42 , 71 , 4 , 83 , 222 &gt;&gt; iex&gt; tweak_key = &lt;&lt; 50 , 8 , 92 , 222 , 223 , 155 , 132 , 50 , 53 , 227 , 114 , 79 , 88 , 11 , 248 , 24 , 239 , 76 , 236 , 39 , 195 , 198 , 112 , 133 , 224 , 41 , 65 , 138 , 91 , 47 , 111 , 43 &gt;&gt; iex&gt; { :ok , _result } = ExSecp256k1 . public_key_tweak_add ( public_key , tweak_key )","ref":"ExSecp256k1.html#public_key_tweak_add/2","title":"ExSecp256k1.public_key_tweak_add/2","type":"function"},{"doc":"Tweak public key by multiplying it Examples iex&gt; public_key = &lt;&lt; 4 , 204 , 170 , 92 , 229 , 234 , 207 , 153 , 33 , 250 , 27 , 208 , 37 , 71 , 183 , 155 , 104 , 155 , 45 , 114 , 7 , 156 , 83 , 199 , 245 , 83 , 32 , 128 , 45 , 174 , 96 , 24 , 38 , 220 , 210 , 198 , 20 , 132 , 174 , 75 , 63 , 131 , 95 , 120 , 101 , 186 , 93 , 179 , 95 , 14 , 206 , 46 , 48 , 6 , 129 , 8 , 146 , 40 , 135 , 251 , 42 , 71 , 4 , 83 , 222 &gt;&gt; iex&gt; tweak_key = &lt;&lt; 50 , 8 , 92 , 222 , 223 , 155 , 132 , 50 , 53 , 227 , 114 , 79 , 88 , 11 , 248 , 24 , 239 , 76 , 236 , 39 , 195 , 198 , 112 , 133 , 224 , 41 , 65 , 138 , 91 , 47 , 111 , 43 &gt;&gt; iex&gt; { :ok , _result } = ExSecp256k1 . public_key_tweak_mult ( public_key , tweak_key )","ref":"ExSecp256k1.html#public_key_tweak_mult/2","title":"ExSecp256k1.public_key_tweak_mult/2","type":"function"},{"doc":"Recover public key from a message, its signature and a recovery id Examples iex&gt; hash = &lt;&lt; 218 , 245 , 167 , 121 , 174 , 151 , 47 , 151 , 33 , 151 , 48 , 61 , 123 , 87 , 71 , 70 , 199 , 239 , 131 , 234 , 218 , 192 , 242 , 121 , 26 , 210 , 61 , 185 , 46 , 76 , 142 , 83 &gt;&gt; iex&gt; r = &lt;&lt; 40 , 239 , 97 , 52 , 11 , 217 , 57 , 188 , 33 , 149 , 254 , 83 , 117 , 103 , 134 , 96 , 3 , 225 , 161 , 93 , 60 , 113 , 255 , 99 , 225 , 89 , 6 , 32 , 170 , 99 , 98 , 118 &gt;&gt; iex&gt; s = &lt;&lt; 103 , 203 , 233 , 216 , 153 , 127 , 118 , 26 , 236 , 183 , 3 , 48 , 75 , 56 , 0 , 204 , 245 , 85 , 201 , 243 , 220 , 100 , 33 , 75 , 41 , 127 , 177 , 150 , 106 , 59 , 109 , 131 &gt;&gt; iex&gt; recovery_id = 0 iex&gt; { :ok , _public_key_binary } = ExSecp256k1 . recover ( hash , r , s , recovery_id ) iex&gt; { :error , :recovery_failure } = ExSecp256k1 . recover ( hash , r , s , 2 )","ref":"ExSecp256k1.html#recover/4","title":"ExSecp256k1.recover/4","type":"function"},{"doc":"Recover public key from a message, its compact signature and a recovery id Examples iex&gt; hash = &lt;&lt; 218 , 245 , 167 , 121 , 174 , 151 , 47 , 151 , 33 , 151 , 48 , 61 , 123 , 87 , 71 , 70 , 199 , 239 , 131 , 234 , 218 , 192 , 242 , 121 , 26 , 210 , 61 , 185 , 46 , 76 , 142 , 83 &gt;&gt; iex&gt; r = &lt;&lt; 40 , 239 , 97 , 52 , 11 , 217 , 57 , 188 , 33 , 149 , 254 , 83 , 117 , 103 , 134 , 96 , 3 , 225 , 161 , 93 , 60 , 113 , 255 , 99 , 225 , 89 , 6 , 32 , 170 , 99 , 98 , 118 &gt;&gt; iex&gt; s = &lt;&lt; 103 , 203 , 233 , 216 , 153 , 127 , 118 , 26 , 236 , 183 , 3 , 48 , 75 , 56 , 0 , 204 , 245 , 85 , 201 , 243 , 220 , 100 , 33 , 75 , 41 , 127 , 177 , 150 , 106 , 59 , 109 , 131 &gt;&gt; iex&gt; recovery_id = 0 iex&gt; { :ok , _public_key_binary } = ExSecp256k1 . recover_compact ( hash , r &lt;&gt; s , recovery_id ) iex&gt; { :error , :recovery_failure } = ExSecp256k1 . recover_compact ( hash , r &lt;&gt; s , 2 )","ref":"ExSecp256k1.html#recover_compact/3","title":"ExSecp256k1.recover_compact/3","type":"function"},{"doc":"Sign a message with the provided private key Examples iex&gt; message = &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 2 &gt;&gt; iex&gt; private_key = &lt;&lt; 120 , 128 , 174 , 201 , 52 , 19 , 241 , 23 , 239 , 20 , 189 , 78 , 109 , 19 , 8 , 117 , 171 , 44 , 125 , 125 , 85 , 160 , 100 , 250 , 195 , 194 , 247 , 189 , 81 , 81 , 99 , 128 &gt;&gt; iex&gt; { :ok , { _r_binary , _s_binary , _recovery_id_int } } = ExSecp256k1 . sign ( message , private_key )","ref":"ExSecp256k1.html#sign/2","title":"ExSecp256k1.sign/2","type":"function"},{"doc":"Sign a message with the provided private key. It returns a compact signature Examples iex&gt; message = &lt;&lt; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 2 &gt;&gt; iex&gt; private_key = &lt;&lt; 120 , 128 , 174 , 201 , 52 , 19 , 241 , 23 , 239 , 20 , 189 , 78 , 109 , 19 , 8 , 117 , 171 , 44 , 125 , 125 , 85 , 160 , 100 , 250 , 195 , 194 , 247 , 189 , 81 , 81 , 99 , 128 &gt;&gt; iex&gt; { :ok , { _signature_bin , _recovery_id_int } } = ExSecp256k1 . sign_compact ( message , private_key )","ref":"ExSecp256k1.html#sign_compact/2","title":"ExSecp256k1.sign_compact/2","type":"function"},{"doc":"Verify a signature of a message Examples iex&gt; message = :crypto . strong_rand_bytes ( 32 ) iex&gt; private_key = :crypto . strong_rand_bytes ( 32 ) iex&gt; { :ok , { signature , _r } } = ExSecp256k1 . sign_compact ( message , private_key ) iex&gt; { :ok , public_key } = ExSecp256k1 . create_public_key ( private_key ) iex&gt; :ok = ExSecp256k1 . verify ( message , signature , public_key )","ref":"ExSecp256k1.html#verify/3","title":"ExSecp256k1.verify/3","type":"function"},{"doc":"","ref":"ExSecp256k1.html#t:error/0","title":"ExSecp256k1.error/0","type":"type"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Use rust_precompiled ( https://github.com/ayrat555/ex_secp256k1/pull/17 ) Rust is not required anymore","ref":"changelog.html#0-7-0","title":"Changelog - 0.7.0","type":"extras"},{"doc":"Update rustler to 0.26","ref":"changelog.html#0-6","title":"Changelog - 0.6","type":"extras"},{"doc":"Update rustler to 0.24","ref":"changelog.html#0-5","title":"Changelog - 0.5","type":"extras"},{"doc":"Add wrappers for more functions Change some error atoms","ref":"changelog.html#0-4","title":"Changelog - 0.4","type":"extras"},{"doc":"Add wrapper for public key compression","ref":"changelog.html#0-3-3","title":"Changelog - 0.3.3","type":"extras"},{"doc":"Add wrapper for public key decompression","ref":"changelog.html#0-3-2","title":"Changelog - 0.3.2","type":"extras"},{"doc":"Add wrapper for additive tweaking of public key","ref":"changelog.html#0-3-1","title":"Changelog - 0.3.1","type":"extras"},{"doc":"Update rustler from 0.22 to 0.23 Update the libsecp256k1 rust library to 0.7.0","ref":"changelog.html#0-3-0","title":"Changelog - 0.3.0","type":"extras"},{"doc":"Update the libsecp256k1 rust library to 0.6.0","ref":"changelog.html#0-2-1","title":"Changelog - 0.2.1","type":"extras"},{"doc":"Update rustler to 0.22.0 for otp 24 support","ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras"},{"doc":"Add sign_compact/2 and recover_compact/3","ref":"changelog.html#0-1-2","title":"Changelog - 0.1.2","type":"extras"},{"doc":"Fix native files","ref":"changelog.html#0-1-1","title":"Changelog - 0.1.1","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras"},{"doc":"NIF for secp256k1 curve functions. It wraps functions from the libsecp256k1 Rust library.","ref":"readme.html","title":"ExSecp256k1","type":"extras"},{"doc":"The package can be installed by adding ex_secp256k1 to your list of dependencies in mix.exs : [ { :ex_secp256k1 , &quot;~&gt; 0.7&quot; } ]","ref":"readme.html#installation","title":"ExSecp256k1 - Installation","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/ex_secp256k1 .","ref":"readme.html#usage","title":"ExSecp256k1 - Usage","type":"extras"},{"doc":"Fork it! Create your feature branch ( git checkout -b my-new-feature ) Commit your changes ( git commit -am 'Add some feature' ) Push to the branch ( git push origin my-new-feature ) Create new Pull Request","ref":"readme.html#contributing","title":"ExSecp256k1 - Contributing","type":"extras"}]